<?php

namespace FunctionalTests\Util;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\HTTP\Request;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\HTTP\Logger\LoggerInfoProvider;

class LoggerInfoProviderImpl implements LoggerInfoProvider {
    /** @var Environment $environment */
    private $environment;
    /** @var EntityManager $entityManager */
    protected $entityManager;

    public function __construct(Environment $environment, EntityManager $entityManager) {
        $this->environment = $environment;
        $this->entityManager = $entityManager;

        $this->operatorRepository = $this->entityManager->getRepository('\Teknisa\Model\Geral\Entities\Operador');
    }

    public function getUserData(Request $request){
        /** @var GeralEntities\Operador $operator */
        $operator = $this->operatorRepository->findOneBy(array('cdoperador' => $this->environment->getCurrentUserId()));
        return json_encode(array(
            "NRORG" => $this->environment->getCurrentOrganizationId(),
            "CDOPERADOR" => $this->environment->getCurrentUserId(),
            "NMOPERADOR" => $operator ? $operator->getNmoperador() : null,
            "END_USER_DATA" => '#'
        ));
    }

    public function getContextData(Request $request){
        $origin = $request->get('origin');
        $origin['END_CONTEXT_DATA'] = '#';
        return json_encode($origin);
    }
}