CREATE TABLE UPDATERPRODFILICX
(
	ID              NUMBER NOT NULL,
	UPDATERPRODID   NUMBER NOT NULL,
	CDFILIAL        VARCHAR2(4) NOT NULL,
	CDCAIXA         VARCHAR2(3) NOT NULL,
	NRVERSAOATUAL	  VARCHAR2(10),
	NRORG             NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO        DATE            DEFAULT SYSDATE,
    DTULTATU          DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
		CONSTRAINT CKC_IDATIVO_UPDATERPRODFILICX CHECK (IDATIVO IN ('S','N')),
		CONSTRAINT PK_UPDATERPRODFILICX PRIMARY KEY (ID),
		CONSTRAINT FKVND00866UPDATERPRODFILICX FOREIGN KEY (UPDATERPRODID) REFERENCES UPDATERPRODUTOS (ID)
)
/

CREATE INDEX VND00866_FK ON UPDATERPRODFILICX (UPDATERPRODID)
/

CREATE SEQUENCE SEQ_UPDATERPRODFILICX START WITH 1 MINVALUE 1 INCREMENT BY 1
/
CREATE OR REPLACE TRIGGER GERA_ID_UPDATERPRODFILICX
BEFORE INSERT ON UPDATERPRODFILICX FOR EACH ROW
BEGIN
    SELECT
        SEQ_UPDATERPRODFILICX.NEXTVAL
    INTO
        :NEW.ID
    FROM
        DUAL;
END;
/
CREATE TABLE UPDATEREVENTOSCX
(
    CDFILIAL        VARCHAR2(4),
    CDCAIXA         VARCHAR(3),
    CDEVENTO	      VARCHAR2(16),
    CDUUID		  VARCHAR2(36),
    CDPRODUCTID	  VARCHAR2(16),
    CDPRODFILIID	  VARCHAR2(16),
    IDSTEVENTO      VARCHAR2(32) NOT NULL CONSTRAINT CKC_STEVENTO_UPDATEREVENTOSCX CHECK (IDSTEVENTO IN ('INSTALACAO_PENDENTE', 'INSTALACAO_EM_CURSO', 'REMOCAO_PENDENTE', 'REMOCAO_EM_CURSO', 'FINALIZADO', 'CANCELADO', 'VERIFICACAO_PENDENTE', 'VERIFICACAO_EM_CURSO', 'ANALISE_INTEGRIDADE_PENDENTE', 'ANALISE_INTEGRIDADE_EM_CURSO')),
    NRVERSAOATUAL	  VARCHAR2(12),
    NRVERSAOALVO	  VARCHAR2(12),
    IDCRIARVERSAO   VARCHAR2(1) DEFAULT 'N' NOT NULL CONSTRAINT CKC_IDCRIAVER_UPDATEREVENTOSCX CHECK (IDCRIARVERSAO IN ('S', 'N')),          
    NRORG             NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO        DATE            DEFAULT SYSDATE,
    DTULTATU          DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
		CONSTRAINT CKC_IDATIVO_UPDATEREVENTOSCX CHECK (IDATIVO IN ('S','N'))
)
/
CREATE TABLE UPDATERHISTORICOCX
(
    CDFILIAL        VARCHAR2(4),
    CDCAIXA         VARCHAR(3),
    CDHISTORICO     VARCHAR2(16),
    CDEVENTO	      VARCHAR2(16),
    CDOPERADOR      VARCHAR2(12),
    CDUUID		  VARCHAR2(36),
    CDPRODUCTID	  VARCHAR2(16),
    NMPRODUCT 	  VARCHAR2(16),
    IDSTEVENTO      VARCHAR2(32) NOT NULL CONSTRAINT CKC_IDSTEVENTO_UPDHISTCX CHECK (IDSTEVENTO IN ('INSTALACAO_PENDENTE', 'INSTALACAO_EM_CURSO', 'REMOCAO_PENDENTE', 'REMOCAO_EM_CURSO', 'FINALIZADO', 'CANCELADO', 'VERIFICACAO_PENDENTE', 'VERIFICACAO_EM_CURSO', 'ANALISE_INTEGRIDADE_PENDENTE', 'ANALISE_INTEGRIDADE_EM_CURSO')),
    NRVERSAOATUAL	  VARCHAR2(12),
    NRVERSAOALVO	  VARCHAR2(12),
    IDCRIARVERSAO   VARCHAR2(1) DEFAULT 'N' NOT NULL,
    NRORG             NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO        DATE            DEFAULT SYSDATE,
    DTULTATU          DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
		CONSTRAINT CKC_IDATIVO_UPDTERHISTORICOCX CHECK (IDATIVO IN ('S','N'))
)
/