### Automao de Testes

##Testes end-2-end (UI)

Os testes do projeto Tecfood/tests/UI so escritos usando o Protractor, o teste oficial framework para testes e2e de aplicaes AngularJS.

Este projeto tenta seguir as melhores prticas descritas no Protractor no site oficial.

A arquitetura deste projeto  descrita abaixo:

 * O arquivo 'protractorconf.js' armazena toda a configurao necessria para execuo dos testes, como o endereo de selnio, diretrio dos testes propriamente ditos,  a url base de onde os testes vo comear, o navegador que os testes sero executados, chamada a biblioteca responsvel por gerar relatrio com as evidncias de teste, etc.

 * Existe tambm um arquivo 'helper.js' para funes gerais que podem ser usadas no diretrio testes, como dormir por alguns segundos, atualizar a pgina, aguardando elemento ficar visivel, etc.

 * O diretrio 'page-objects' contm endereos dos elementos web, o encapsulamento dos atributos e funes utilizados pelo repositrio dos testes (spec). Isso ocorre para evitar duplicao de cdigo e facilitar a manuteno do cdigo.

 * E o diretrio ** specs ** contm os testes, onde cada conjunto de testes  separado por arquivo spec. Tambm contm a pasta SmokeTest, que contm os testes que testa o mnimo de funcionalidades, os mesmos podem ser usados a cada build e tambm serem chamados nos testes de regresso quando for necessrio passar por uma outra tela antes do teste final.

 * O arquivo package.json consta as dependncias do projeto com suas respectivas verses. O mesmo visa a instalao da ferramenta e suas dependncias de forma incorreta. Ou seja, o uso do mesmo evita o uso de comandos de instalaes.

## Instalao local:

i) Copie a pasta do diretrio abaixo para "C:\Users\seu usurio login\AppData\Roaming"
L:\Grupo Teknisa\Teknisa Service\Centro de PRODUTO\Diviso TecFood\Teste\09_TestesAutomatizados\Programas\npm

ii) Para instalar o framework de teste e suas dependncias, utilize o arquivo package.json, utilize o comando no diretrio do projeto /tests/.
npm i

## Boas prticas 

 * O page-objects alm de encapsular funes e atributos para facilitar a manuteno, o padro tambm serve para dar legitimidade aos testes. Logo, os arquivos de teste (spec) no devem ter conter nos casos de teste ("it"): i) funes, ii) locator (endereo do elemento) ou aes que poderiam ser encapsuladas deixando os testes mais limpos;

 * Todo teste deve estar no padro AAA, ou seja, deve ter o Arrange ( a pr-condio do teste), Act (os passos executados na aplicao (so os inputs)) e Assert (verificao (output),  o passo que torna esta automao um teste realmente);

 * Os arquivos page-objects devem ter a nomenclatura "nome_da_tela.po.js"

 * Funes que so utilizadas em mais de uma tela estaro em um arquivo "geral.tecfood.po.js" ou "geral.po.js". Ex: Filtro Servio, prato....

 * No deve haver require de um page-objects em outros, pois, isso invlida-o;

 * No utilize elemento xpath, pois, esse locator  mais lento. D preferncia para o ID, NAME e CSS.

 * Funes gerais criadas devem ser commitadas o quanto antes e comunicado ao restante da equipe via o grupo no chat.

 * Utilize a conveo JS para escrever os cdigos.

## Execuo dos testes

Execute webdriver-manager  - No prompt de comando informe: webdriver-manager start
Em outro prompt, acesse o repositrio \tests e execute: protractor protractorconf.js
Ao final dos testes, verifique o relatrio com as evidncias na pasta \tests\UI\screenshots.
