var configParams = require("./configParams.js");
//var HtmlScreenshotReporter = require('C:/Users/matheuscamara/AppData/Roaming/npm/node_modules/protractor-jasmine2-screenshot-reporter');
var HtmlScreenshotReporter = require('protractor-jasmine2-screenshot-reporter');
var reporter = new HtmlScreenshotReporter({
  dest: 'errors/',
  filename: 'my-report.html'/*,
  ignoreSkippedSpecs: true,
  captureOnlyFailedSpecs: true,
  showSummary: true,
  showQuickLinks: true*/
});

exports.config = {
    framework: 'jasmine2',
    restartBrowserBetweenTests: true,

    seleniumAddress: configParams.seleniumAddress,
    specs: [
        'specs/*.spec.js'
        
    ],
    capabilities: {
        browserName: 'chrome',
        chromeOptions: {
      args: ['disable-popup-blocking', 'test-type','disable-extensions','disable-web-security','incognito']
    }
    },
    allScriptsTimeout: 100000, // 1 minuto de timeout
    getPageTimeout: 30000, // 20 segundos de timeout para carregar o angular

    jasmineNodeOpts: {
        defaultTimeoutInterval: 150000, // 2,5 minutos de timeout
    },
    params: {
        applicationUrl: configParams.functionalTest
    },

    beforeLaunch: function() {
    	return new Promise(function(resolve){
      		reporter.beforeLaunch(resolve);
    	});
  	},

  	onPrepare: function() {
    	jasmine.getEnv().addReporter(reporter);
  	},

  	afterLaunch: function(exitCode) {
    	return new Promise(function(resolve){
      		reporter.afterLaunch(resolve.bind(this, exitCode));
    	});
  	},

    rootElement: 'html'
};