'use strict';

function requisicaoPorServico(){

	var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	var z = new ZeedhiAPIConstructor(browser, protractor);

	this.gridId = '197774849324940559495113';
	var page = this;

	this.abrir = function(rotina = 'N'){  
		browser.waitForAngular();
		z.component.menu.open();
        z.component.menu.clickByLabel('Planejamento');
        z.component.menu.clickByLabel('Requisição');
        z.component.menu.clickByLabel('Requisição por Serviço');

        browser.waitForAngular();
		//page.validateAclConfig();
        if(rotina == 'N'){
        	z.application.waitZhLoading();
        	z.component.alert.clickMessageOk(); //Contorna o problema de mensagens do console
    	}
	};
	this.validateAclConfig = function(){
			return element.all(by.css('span.notification-message-text.ng-binding')).reduce(function(result, elem, index){
				if(result) return result;

				//return z.widget.grid.getText('197774849324940559495113', index, column, true).then(function(text){
				return elem.getText().then(function(text){
					if(text.indexOf("Cannot read property 'id'") != -1) {
						return true;
					}
				});
			}).then(function(result){
				if(!result) return false;

				else{
					z.application.openOnContainer('#/pla_requisicao#pla00600_requisicao_por_servico');
					page.validateAclConfig();
				}
			});
	}
	this.selecionarServico = function(nmservico){
		z.field.fieldFunctions.click('NMSERVICO');
		z.widget.grid.click('NMSERVICO', nmservico,'0');
	};

	this.selecionarProduto = function(tipoproduto){
		z.field.fieldFunctions.click('IDPREVRETINAME');
		z.widget.list.clickItem(tipoproduto);
	};

	//Dia: Dia do calendário a ser selecionado, caso nenhum valor seja informado, o default será o dia atual.
	this.selecionarData = function(dia = 'today'){
		z.field.fieldFunctions.click('DTPREVRETI');

		if(dia != 'today'){
			element.all(by.repeater('day in week')).reduce(function(result, elem, index){
				if(result) return result;

				return elem.getText().then(function(text){
					if(text == dia) return elem;
				});
			}).then(function(result){
				if(!result) throw new Error("Dia não encontrado");

				else
					result.click();
			});
		}
		
		else{
			element(by.css('.day .ng-scope .today')).click();
		}
	};

	this.filtroInicial = function(nmservico, tipoproduto, data){
		page.selecionarServico(nmservico);
		page.selecionarProduto(tipoproduto);
		page.selecionarData(data);

		z.component.footer.clickRightActionByLabel('Filtrar');
	};

	this.filtrarProduto = function(nmproduto){
		z.field.fieldFunctions.click('NMPRODUTO');

		//Ao abrir o grid, o cursor deve estar no campo de pesquisa.
		z.util.pressKey(nmproduto);
		z.widget.grid.click('NMPRODUTO',nmproduto,'0');
	};

	/*
	nmcampo = Nome do campo (elemento) que será utilizado para filtrar o calendário
	dia = Dia do calendário a ser selecionado, caso nenhum valor seja informado, o default será o dia atual.
	*/
	this.selecionarDataCalendario = function(nmcampo, dia = 'today'){
		z.field.fieldFunctions.click(nmcampo);

		if(dia != 'today'){
			element.all(by.repeater('day in week')).reduce(function(result, elem, index){
				if(result) return result;

				return elem.getText().then(function(text){
					if(text == dia) return elem;
				});
			}).then(function(result){
				if(!result) throw new Error("Dia não encontrado");

				else
					result.click();
			});
		}
		
		else{
			element(by.css('.day .ng-scope .today')).click();
		}
	};

	/*
	hora = Hora a ser selecionada, caso não seja informada o default será 01
	minuto = Minuto a ser selecionado, caso não seja informado o default será 01
	CORRIGIR
	*/
	this.selecionarHoraLimite = function(hora = '01', minuto = '01'){
		z.field.fieldFunctions.click('HRLIMITERETI');
		element(by.css('body > div.mbsc-mobiscroll.dw-bottom > div > div.dw.dw-ltr > div > div.dwcc > div > div > div:nth-child(1) > div > div.dwww > div.dww > div > div:nth-child(1) > div.dw-li.zh-picker-text-unselected.dw-v.dw-sel > div')).click().then(function(){
			console.log('clicou');
			browser.sleep(5000);
		});
	};

	this.adicionarProduto = function(nmproduto, qtExtra, qtDevolvida, qtLiberada, dtLimite, hrLimite){
		z.component.footer.clickCenterActionByIcon('plus');

		page.filtrarProduto(nmproduto);

		z.field.fieldFunctions.fill('QTPREVEXTRA','1', true);
		page.selecionarDataCalendario('DTLIMITERETI');
		z.component.footer.clickRightActionByLabel('Salvar');
	};

	/*
	197774849324940559495113 = gridId
	row = id da linha do grid, iniciando por 0, default = 0
	column =  int - id da coluna do grid, iniciando por 0, default = 0
	checkBox = booleano ( True se o grid possui checkbox), default = false
	*/
	this.getGridText = function(row = 0, column = 0, checkBox = false){ 
		return z.widget.grid.getText('197774849324940559495113',row, column, true);
	};

	this.getGridNrRows = function(){
		return z.widget.grid.getNrRows('pla00600_requisicaoServicoGRID');
	};

	/*Abre o swipe de um produto
	nmproduto: Nome do produto exibido no grid principal da tela que tera o swipe aberto. 
	Default = 'naoSelecionado', nesta opção,
	o primeiro produto exibido no grid terá seu swipe aberto.*/
	this.abrirSwipeProduto = function (nmproduto = 'naoSelecionado'){
		if(nmproduto == 'naoSelecionado')
			z.widget.grid.clickColumn(page.gridId, 0, 1, true);

		else
			z.widget.grid.click('NMPRODUTO', nmproduto, '197774849324940559495113', false);
	};

	this.alterarProduto = function(nmproduto, qtExtra){
		page.abrirSwipeProduto(nmproduto);
		z.field.fieldFunctions.fill('QTPREVEXTRA',qtExtra, false);
		z.component.footer.clickRightActionByLabel('Salvar');
	};

	this.getQtdExtra = function(){
		return element(by.id('QTPREVEXTRA')).getAttribute('value');
	}
	/*
	Funcionalidade: Verifica todas as registros(linhas do grid) em busca de determinado texto em determinada coluna
					A busca é finalizada no momento em que o primeiro registro válido é encontrado.
	column = int - id da coluna a ser utilizada na busca, iniciando por 0, default = 1
	*/
	this.gridHasText = function(column = 1, searchText, hasCheckBox = false){
		return element.all(by.repeater('rowIndex in filtered')).reduce(function(result, elem, index){
				if(result) return result;

				//return z.widget.grid.getText('197774849324940559495113', index, column, true).then(function(text){
				return page.getGridText(index, column, hasCheckBox).then(function(text){
					if(text == searchText) {
						return true;
					}
				});
			}).then(function(result){
				if(!result) return false;

				else
					return result;
			});
	};

	/*
	Funcionalidade: Retorna a linha do grid na qual um valor informado (searchText) se encontra
	column: Default = 1 - Coluna na qual o valor será pesquisado
	searchText: texto da busca
	hasCheckBox: Default = false - Se o grid possui ou não checkBox
	*/
	this.getValueRowInGrid = function(column = 1, searchText, hasCheckBox = false){
			return element.all(by.repeater('rowIndex in filtered')).reduce(function(result, elem, index){
				if(result) return result;

				return page.getGridText(index, column, hasCheckBox).then(function(text){
					if(text == searchText) {
						return index;
					}
				});
			}).then(function(result){
				if(!result) return -1;

				else
					return result;
			});
	};

	/*
	Funcionalidade: Clicar no componente de Calcular Requisição e confirmar ou cancelar a operação de acordo com parâmetro
	calcular: Default = 'S' - Indica se o cálculo será confirmado ('S') ou negado ('N') na mensagem de confirmação
	*/
	this.calcularRequisicao = function(calcular = 'S'){
		z.component.footer.clickCenterActionByIcon('tasks');
		if(calcular == 'S')
			z.component.alert.clickButton('Sim');

		else if(calcular == 'N')
			z.component.alert.clickButton('Não');
	};

	/*
	Funcionalidade: Seleciona um produto no grid e o exclui
	searchText: Texto a ser encontrado no grid para que seja excluído.
	column: Default = 1 . 0 =  busca na coluna  Código . 1 = busca na coluna nome
	*/
	this.excluirProduto = function(searchText, column = 1){
		page.getValueRowInGrid(column, searchText, true).then(function(row){

			//Significa que encontrou o produto.
			if(row > -1)
				z.widget.grid.clickColumn(page.gridId, row, -1, true);

			else
				throw 'Produto não encontrado ['  + column + ' ' + searchText + ' ]';
		});

		z.component.footer.clickCenterActionByIcon('trash');
		z.component.alert.clickButton('Sim');
		z.component.alert.clickMessageOk();
	};

	/*
	Funcionalidade: Seleciona um produto no grid e edita o valor de um dos campos
	searchText: Texto a ser encontrado no grid para que seja excluído.
	columnSearch: Default = 1 . 0 =  busca na coluna  Código . 1 = busca na coluna nome
	columnEdit: id da coluna a ser editada, começando em 0
	*/
	this.editarProdutoGrid = function(searchText, columnSearch, columnEdit, value){
		page.getValueRowInGrid(columnSearch, searchText, true).then(function(row){

			if(row > -1){
				z.widget.grid.editInlineFieldValue(value, row, columnEdit, page.gridId, true);
				browser.actions().sendKeys(protractor.Key.ENTER).perform();
				z.component.footer.clickRightActionByLabel('Salvar');
			}

			else
				throw 'Produto não encontrado ['  + columnSearch + ' ' + searchText + ' ]';
		});
	};
}

module.exports = new requisicaoPorServico();